// ATTiny85 Based Serial G-Code injector
// Steve Croot
// March 2020

#include <SendOnlySoftwareSerial.h>
  
  #define BUTTON_1 0                                // Button 1 input (HOME XYZ)
  #define BUTTON_2 1                                // Button 2 input (HOME XY)
  #define BUTTON_3 2                                // Button 3 input (RESET ORIGIN)
  #define OscTrim 3                                 // Crystal trim pot 

  SendOnlySoftwareSerial MarlinSerial (4);          // Serial TX pin

  unsigned long CurrentMillis;                      // Timer elements for delayed button press
  unsigned long ButtonMillis;          
  int ButtonDelay=2000;                             // Button delay in milliseconds. Adjust to suit or 0 for off.


void setup() {  //-------------------------------------------------------------------------------------- 
  
  MarlinSerial.begin(250000);

  pinMode(BUTTON_1, INPUT);
  pinMode(BUTTON_2, INPUT);
  pinMode(BUTTON_3, INPUT);

}

void loop() {  //----------------------------------------------------------------------------------------

  CurrentMillis=millis();                                                                                                                                                                                                                                                                                                                    

  int val = analogRead(OscTrim);                     // Obtain the adjustment value
  OSCCAL = val/4;                                    // Adjust the oscillator 
  
  //MarlinSerial.print("OSCCAL = ");MarlinSerial.println(OSCCAL, HEX);delay(200);                // Uncomment this line to help tune the crystal (DO NOT LEAVE ACTIVE ONCE TUNED!)

  if (digitalRead (BUTTON_1) == HIGH){                                                           // Button 1 command (Home all)
       do{
           if (millis()-CurrentMillis>ButtonDelay){
              MarlinSerial.println("G28 X Y Z");    
              do{delay(2);}while(digitalRead (BUTTON_1) == HIGH);
           }
       } while(digitalRead (BUTTON_1) == HIGH);       
  }         

  if (digitalRead (BUTTON_2) == HIGH){                                                           // Button 2 command (Home X Y)
       do{
           if (millis()-CurrentMillis>ButtonDelay){
              MarlinSerial.println("G28 X Y");    
              do{delay(2);}while(digitalRead (BUTTON_2) == HIGH);
           }
       } while(digitalRead (BUTTON_2) == HIGH);       
  }         

  if (digitalRead (BUTTON_3) == HIGH){                                                           // Button 3 command (Reset origin)
       do{
           if (millis()-CurrentMillis>ButtonDelay){
              MarlinSerial.println("G92 X0 Y0 Z0");    
              do{delay(2);}while(digitalRead (BUTTON_3) == HIGH);
           }
       } while(digitalRead (BUTTON_3) == HIGH);       
  }         
   
} //---------------------------------------------------------------------------------------------------------
